\name{1. supr3-package}
\alias{supr3-package}
\alias{supr3}
\docType{package}
\title{
SupR: an experimental R package for parallel and distributed computing

}
\description{
Support for parallel and distributed computation, including
multithreading, distributed file and memory management, and
flexible cluster-wise iterative computing.
}
\details{

SupR consists of three main components:

\enumerate{
    \item \emph{Cluster}: a cluster that is based on
         a collection of stand-alone programs, namely,
	 \code{driver}, \code{master}, \code{worker}, and \code{taskrunner}.
         These programs and those for DDS/DFS (\code{dfs_name} to run
	 as a namenode, and \code{dfs_data} to run datanodes),
	 are available in package's bin directory.
	 The \emph{context} function provides
	 as a main user interface to start and stop components of a cluster.

	 The package provides a set of functions for implementing SupR's method
	 for cluster-wide iterative statistical computing on distributed data,
	 including those known as map-and-reduce or map-and-combine.

    \item \emph{SDFS}: a distributed file system, or more generally,
         a distributed object system.
        The user interface functions to access DFS
	have their names starting with \emph{DD}. 

    \item \emph{Thread}: a set of functions for multithreading,
          reflecting a collection of experimental efforts to
	  use multithreading in R without any change of the R
	  system code.
%    \item \emph{Rython}: a collection of R and Python functions for interface to Python \link{https://www.python.org}.
         
}

%The DESCRIPTION file:
%\packageDESCRIPTION{supr2}
%\packageIndices{supr2}
%~~ An overview of how to use the package, including the most important ~~
%~~ functions ~~
}
\author{
Chuanhai Liu

Maintainer: Chuanhai Liu
}
\references{
	\link{http://www.stat.purdue.edu/~chuanhai}
}
%~~ Optionally other standard keywords, one per line, from file KEYWORDS in ~~
%~~ the R documentation directory ~~
\keyword{ package }
\seealso{
%~~ Optional links to other man pages, e.g. ~~
%~~ \code{\link[<pkg>:<pkg>-package]{<pkg>}} ~~
	  \code{cluster} 
	  \code{dfs} 
	  \code{thread}
}
\examples{
\dontrun{

  library(supr3)
  context()
  typeof(context())
  unlist(context()$ths)

  # Turn on verbose mode, 0 <= verbose <= 3L. Large values of verbose
  # increase the verbosity

  supr.options(info=TRUE)  # or supr.options(verbose=1L) [TODO]
  supr.options(debug=TRUE) # or supr.options(verbose=3L) [TODO]

  context(driver = context()$driver)
  context()$driver$connections

  context(shutdown)

}

}
